# KEKS -- Python KEKS implementation
# Copyright (C) 2024-2025 Anton Rudenko <rudenko.ad@phystech.edu>
#               2024-2025 Sergey Matveev <stargrave@stargrave.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.

from unittest import TestCase

from hypothesis import given
from hypothesis.strategies import integers

from keks import NotEnoughData


class TestNotEnoughData(TestCase):
    @given(integers(min_value=1, max_value=100))
    def test_str(self, integer: int) -> None:
        self.assertEqual(
            str(NotEnoughData(integer)),
            "{} bytes expected".format(integer),
        )

    @given(integers(min_value=1, max_value=100))
    def test_repr(self, integer: int) -> None:
        self.assertEqual(
            NotEnoughData(integer).__repr__(),
            "NotEnoughData({} bytes expected)".format(integer),
        )

    @given(integers(min_value=1, max_value=100))
    def test_init(self, integer: int) -> None:
        self.assertEqual(NotEnoughData(integer).n, integer)
